package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.BERSequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;

public class CompressedData extends ASN1Encodable {
   private DERInteger version;
   private AlgorithmIdentifier compressionAlgorithm;
   private ContentInfo encapContentInfo;

   public CompressedData(AlgorithmIdentifier compressionAlgorithm, ContentInfo encapContentInfo) {
      CompressedData var10000 = this;
      CompressedData var10001 = this;
      CompressedData var10002 = this;
      super();
      DERInteger var3;
      var3 = new DERInteger.<init>(0);
      var10002.version = var3;
      var10001.compressionAlgorithm = compressionAlgorithm;
      var10000.encapContentInfo = encapContentInfo;
   }

   public CompressedData(ASN1Sequence seq) {
      this.version = (DERInteger)seq.getObjectAt(0);
      this.compressionAlgorithm = AlgorithmIdentifier.getInstance(seq.getObjectAt(1));
      this.encapContentInfo = ContentInfo.getInstance(seq.getObjectAt(2));
   }

   public static CompressedData getInstance(ASN1TaggedObject _ato, boolean _explicit) {
      return getInstance(ASN1Sequence.getInstance(_ato, _explicit));
   }

   public static CompressedData getInstance(Object _obj) {
      if (_obj != null && !(_obj instanceof CompressedData)) {
         if (_obj instanceof ASN1Sequence) {
            return new CompressedData((ASN1Sequence)_obj);
         } else {
            throw new IllegalArgumentException("Invalid CompressedData: " + _obj.getClass().getName());
         }
      } else {
         return (CompressedData)_obj;
      }
   }

   public DERInteger getVersion() {
      return this.version;
   }

   public AlgorithmIdentifier getCompressionAlgorithmIdentifier() {
      return this.compressionAlgorithm;
   }

   public ContentInfo getEncapContentInfo() {
      return this.encapContentInfo;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.version);
      var1.add(this.compressionAlgorithm);
      var10000.add(this.encapContentInfo);
      return new BERSequence(var1);
   }
}
